// mmc and AVR By Behnam Zakizadeh with WinAVR gcc compiler @ 31.Oct.2014 [1393/08/09]
// website: AVR64.com
// license: freeware

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "global.h"		
#include "rprintf.h"	
#include "timer.h"		
#include "lcd.h"
#include "uart.h"
#include "debug.h"
#include "spi.h"		
#include "mmc.h"		

int main(void)
{
	u32 sector=0;
	u08 buffer[0x200];
	u08 reset_status = 0;
	u08 read_status = 0;
	u32 offset=0;
	u32 rootDirectory=0;
	u32 reservedSector=0;
	u32 sectorPerFat=0;
	u32 numberOfFat=0;
	u32 sectorPerCluster=0;
	u32 addrOfFirstFileinFat=0;
	u32 realAddrOfFirstFile=0;
	u08 wrstate=0;

	_delay_ms(1000); // very important! (wait for mmc startup)
	lcdInit();
	rprintfInit(lcdDataWrite);
	rprintf("Reset MMC");
	_delay_ms(1000);
	lcdClear();
	
	mmcInit();
	reset_status = mmcReset();
	
	//uartInit();
	//uartSetBaudRate(115200);
	//rprintfInit(uartSendByte);
	//rprintf("\r\nWelcome to AVRlib!\r\n");
	
	lcdGotoXY(0,0);
	rprintf("reset_status=%d", reset_status);
	_delay_ms(1000);
	lcdClear();
	
	for(u32 i=0;i<1000;i++)
	{
		lcdClear();
		read_status = mmcRead(i, buffer);
		lcdGotoXY(0,0);
		rprintf("Sector=%d-rd=%d", i, read_status);
		lcdGotoXY(0,1);
		rprintf("data=%c%c%c%c%c%c%c%c", buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10]);

		if(buffer[3]=='M' && buffer[4]=='S' && buffer[5]=='D' && buffer[6]=='O' && buffer[7]=='S' && buffer[8]=='5'  && buffer[9]=='.'  && buffer[10]=='0')
		{
			sector = i;
			break;
		}
		//if(buffer[3]=='a' && buffer[4]=='n' && buffer[5]=='d' && buffer[6]=='r' && buffer[7]=='o' && buffer[8]=='i'  && buffer[9]=='d'  && buffer[10]==' ')
		//	break;
		
		_delay_ms(50);
	}
	
	_delay_ms(10000);
	
	// claculate start address of file
	offset = sector;
	reservedSector = (reservedSector << 8) + buffer[15];
	reservedSector = (reservedSector << 8) + buffer[14];
	
	clr();
	rprintf("rsv=%d", reservedSector);
	
	clr2();
	rprintf("offset=%d", offset);
	
	_delay_ms(1000);

	numberOfFat = buffer[16];
	sectorPerFat = (sectorPerFat << 8) + buffer[39];
	sectorPerFat = (sectorPerFat << 8) + buffer[38];
	sectorPerFat = (sectorPerFat << 8) + buffer[37];
	sectorPerFat = (sectorPerFat << 8) + buffer[36];

	clr();
	rprintf("numFAT=%d", numberOfFat);
	
	clr2();
	rprintf("SecPrFAT=%d", sectorPerFat);
	
	_delay_ms(1000);

	rootDirectory = reservedSector+offset+(sectorPerFat*numberOfFat);
	sectorPerCluster = buffer[13];
	
	clr();
	rprintf("RootDir=%d", rootDirectory);
	
	clr2();
	rprintf("SecPrClustr=%d", sectorPerCluster);
	
	_delay_ms(1000);
	
	mmcRead(rootDirectory, buffer);
	clr();
	rprintf("Fnme=%c%c%c%c%c%c%c%c%c%c%c%c", buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11]);
	
	addrOfFirstFileinFat = (addrOfFirstFileinFat << 8) + buffer[27];
	addrOfFirstFileinFat = (addrOfFirstFileinFat << 8) + buffer[26];
	
	clr2();
	rprintf("filAdOfst=%d", addrOfFirstFileinFat);
	
	_delay_ms(1000);
	
	realAddrOfFirstFile = rootDirectory + ( (addrOfFirstFileinFat-2)*sectorPerCluster );
	
	clr();
	rprintf("fileAddr=%d", realAddrOfFirstFile);
	
	mmcRead(realAddrOfFirstFile, buffer);
	
	clr2();
	rprintf("t=%c%c%c%c%c%c%c%c%c%c%c%c", buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11]);
	
	buffer[0] = 'w';// replace first char of file with w
	
	wrstate = mmcWrite(realAddrOfFirstFile, buffer);// write changes to file
	
	clr();
	rprintf("wrstate=%d", wrstate);
	
	return 0;
}

void clr(void)
{
	lcdGotoXY(0,0);
	rprintf("                ");
	lcdGotoXY(0,0);
}

void clr2(void)
{
	lcdGotoXY(0,1);
	rprintf("                ");
	lcdGotoXY(0,1);
}
